package io.github.beradq.adybubbles

import org.bukkit.command.CommandSender
import org.bukkit.entity.Player
import taboolib.common.platform.command.CommandBody
import taboolib.common.platform.command.CommandHeader
import taboolib.common.platform.command.subCommand
import taboolib.platform.util.nextChatInTick

@CommandHeader("bubbles-chat")
object BubblesChatCommand {
    @CommandBody
    val edit = subCommand {
        dynamic("NPC_ID") {
            suggestion<CommandSender>(uncheck = true) { sender, _ ->
                AdyBubbles.adyApi.getEntityFinder().getEntities().map { it.id }
            }
            execute<CommandSender> { sender, context, _ ->
                val npcId = context["NPC_ID"]
                val npcList = AdyBubbles.adyApi.getEntityFinder().getEntitiesFromId(npcId)
                if (npcList.size == 1) {
                    TraitBubblesChat.edit(sender as Player, npcList.first())
                } else {
                    sender.sendMessage("找到了${npcList.size}个NPC:")
                    npcList.withIndex().forEach {
                        sender.sendMessage("${it.index + 1}: ${it.value.uniqueId}")
                    }
                    sender.sendMessage("请通过聊天输入序号指定NPC")
                    (sender as Player).nextChatInTick(20 * 10, {
                        val npc = npcList[it.toInt() - 1]
                        TraitBubblesChat.edit(sender, npc)
                    }, {
                        sender.sendMessage("超时")
                    })
                }

            }
        }
    }
}